love.graphics.setBackgroundColor(1, 1, 1)
maps = {{},{},{},{},{}}
require("map")
local player = {x = 0, y = 0, r = 10, speedX = 0, speedY = 0, viewX = 0, viewY = 0, eyeFollow = true}
local menu = 1
local map
local menuButtons = {}
local restartButton = {x = 710, y = 10, w = 80, h = 80}
local music = {}
local images = {}
local fontSize = {}
for i = 1, 100 do
  fontSize[i] = love.graphics.newFont(i)
end
local zoom = 100
function love.load()
  images.restart = love.graphics.newImage("restart.png")
end
function isInside(x, y, w, h, X, Y)
  if X > x and X < x + w and Y > y and Y < y + h then return true end
  return false
end
function newMenuButton(x, y, w, h, inMenu, lable, toScene)
  local button = {x = x, y = y, w = w, h = h, inMenu = inMenu, lable = lable, toScene}
  menuButtons[#menuButtons + 1] = button
  function draw(self)
    if menu == self.inMenu then
      love.graphics.setFont(fontSize[30])
      love.graphics.setColor(0.5, 0.5, 1)
      love.graphics.rectangle("fill", self.x, self.y, self.w, self.h)
      love.graphics.setColor(0, 0, 0)
      love.graphics.rectangle("line", self.x, self.y, self.w, self.h)
      love.graphics.setColor(0, 0, 0)
      love.graphics.printf(self.lable, self.x, self.y + self.h/3 ,self.w, "center")
    end
  end
  function clicked(self, X, Y)
    if menu == self.inMenu and isInside(self.x, self.y, self.w, self.h, X, Y) then
      if toScene[1] == 0 then
        if menu >= 2 then
          startGame(maps[inMenu][toScene[2]])
        end
      end
      menu = toScene[1]
      return true
    end
    return false
  end
  button.draw = draw
  button.clicked = clicked
end
newMenuButton(50, 50, 700, 100, 1, "levels", {2})
newMenuButton(50, 50, 100, 100, 2, 1, {0, 1})
newMenuButton(200, 50, 100, 100, 2, 2, {0, 2})
newMenuButton(350, 50, 100, 100, 2, 3, {0, 3})
newMenuButton(500, 50, 100, 100, 2, 4, {0, 4})
newMenuButton(50, 200, 700, 100, 1, "maps", {3})
newMenuButton(50, 50, 100, 100, 3, 1, {0, 1})
newMenuButton(200, 50, 100, 100, 3, 2, {0, 2})
newMenuButton(350, 50, 100, 100, 3, 3, {0, 3})
newMenuButton(500, 50, 100, 100, 3, 4, {0, 4})
function love.draw()
  if menu == 0 then
    map:draw()
    player:draw()
    restartButton:draw()
  else
    for i = 1, #menuButtons do
      menuButtons[i]:draw()
    end
  end
end
function love.update(dt)
  if menu == 0 then
    if zoomIn and zoom >= 10 then
      zoom = zoom - 1
    end
    if zoomOut and zoom <= 300 then
      zoom = zoom + 1
    end
    if player.eyeFollow == false then
      if left then player.viewX = player.viewX - 5 end
      if right then player.viewX = player.viewX + 5 end
      if up then player.viewY = player.viewY - 5 end
      if down then player.viewY = player.viewY + 5 end
    end
    map:update(dt)
    player:update(dt)
  end
end
function love.mousepressed(x, y, button)
  if menu == 0 then
    if restartButton:clicked(x, y) then return end
  else
    for i = 1, #menuButtons do
      if menuButtons[i]:clicked(x, y) then return end
    end
  end
end
function love.keypressed(k)
  if k == "p" then clean() end
  if k == "up" then up = true
  elseif k == "down" then down = true
  elseif k == "left" then left = true
  elseif k == "right" then right = true
  end
  if menu == 0 then
    if k == "q" then
      zoomIn = true
    elseif k == "e" then
      zoomOut = true
    end
    if k == "space" then player.eyeFollow = player.eyeFollow == false end
    if k == "w" then player.up = true
    elseif k == "s" then player.down = true
    elseif k == "a" then player.left = true
    elseif k == "d" then player.right = true
    end
  end
end
function love.keyreleased(k)
  if k == "up" then up = false
  elseif k == "down" then down = false
  elseif k == "left" then left = false
  elseif k == "right" then right = false
  end
  if menu == 0 then
    if k == "q" then
      zoomIn = false
    elseif k == "e" then
      zoomOut = false
    end
    if k == "w" then player.up = false
    elseif k == "s" then player.down = false
    elseif k == "a" then player.left = false
    elseif k == "d" then player.right = false
    end
    if k == "a" or k == "d" then
      player.deltaSpeedX = 1
    end
    if k == "w" or k == "s" then
      player.deltaSpeedY = 1
    end
  end
end
function restartButton:draw()
  love.graphics.setColor(1, 1, 1)
  love.graphics.draw(images.restart, 700, 0, 0, 0.1)
end
function restartButton:clicked(x, y)
  if isInside(self.x, self.y, self.w, self.h, x, y) then
    local Map = map.model
    clean()
    startGame(Map)
  end
end
function player:draw()
  local z = zoom/100
  love.graphics.setColor(0.2, 0.2, 1)
  love.graphics.circle("fill", (player.x - player.viewX)*z + 400, (player.y - player.viewY)*z + 300, player.r*z)
end
function player:update(dt)
  player.x = player.x + math.ceil(player.speedX/25)
  player.y = player.y + math.ceil(player.speedY/25)
  if player.left then
    player.speedX = player.speedX - 5
  elseif player.speedX < 0 then
    player.speedX = player.speedX + 2
  end
  if player.right and player.left ~= true then
    player.speedX = player.speedX + 5
  elseif player.speedX > 0 then
    player.speedX = player.speedX - 2
  end
  if player.up then
    player.speedY = player.speedY - 5
  elseif player.speedY < 0 then
    player.speedY = player.speedY + 2
  end
  if player.down and player.up ~= true then
    player.speedY = player.speedY + 5
  elseif player.speedY > 0 then
    player.speedY = player.speedY - 2
  end
  if player.eyeFollow then
    player.viewX = player.x
    player.viewY = player.y
  end
  for i = 1, #map.goals do
    local goal = map.goals[i]
    local dx = player.x - goal.x
    local dy = player.y - goal.y
    if math.sqrt(dx*dx + dy*dy) < player.r + map.goals.r then
      table.remove(map.goals, i)
      break
    end
  end
  if #map.goals == 0 then
    clean()
    return
  end
  for i = 1, #map.red do
    local red = map.red[i]
    if isInside(red.x - player.r, red.y - player.r, red.w + 2*player.r, red.h + 2*player.r, player.x, player.y) then
      local Map = map.model
      clean()
      startGame(Map)
    end
  end
end
function clean()
  player.r = 10
  player.speedX = 0
  player.speedY = 0
  player.left = false
  player.right = false
  player.up = false
  player.down = false
  map = nil
  menu = 1
end
function startGame(Map)
  menu = 0
  map = instMap(Map)
end
function instMap(Map)
  local instance = {timeout = Map.timeout, red = {}, safe = {}, goals = {r=Map.goals.r}}
  for i = 1, #Map.red do
    instance.red[i] = Map.red[i]
  end
  for i = 1, #Map.safe do
    instance.safe[i] = Map.safe[i]
  end
  for i = 1, #Map.goals do
    instance.goals[i] = Map.goals[i]
  end
  player.x = Map.playerStart.x
  player.y = Map.playerStart.y
  player.viewX = player.x
  player.viewY = player.y
  function instance:draw()
    local z = zoom/100
    for i = 1, #self.red do
      local red = self.red[i]
      love.graphics.setColor(1, 0, 0)
      love.graphics.rectangle("fill", (red.x - player.viewX)*z + 400, (red.y - player.viewY)*z + 300, red.w*z, red.h*z)
    end
    for i = 1, #self.safe do
      local safe = self.safe[i]
      love.graphics.setColor(0.3, 1, 0.3)
      love.graphics.rectangle("fill", (safe.x - player.viewX)*z + 400, (safe.y - player.viewY)*z + 300, safe.w*z, safe.h*z)
    end
    for i = 1, #self.goals do
      local goal = self.goals[i]
      love.graphics.setColor(0.4, 0.3, 0.7)
      love.graphics.circle("fill", (goal.x - player.viewX)*z + 400, (goal.y - player.viewY)*z + 300, self.goals.r*z)
    end
    love.graphics.setFont(fontSize[50])
    love.graphics.setColor(0, 0, 0)
    love.graphics.print(math.ceil(self.timeout), 10, 10)
  end
  function instance:update(dt)
    for i = 1, #self.safe do
      local safe = self.safe[i]
      if isInside(safe.x - player.r, safe.y - player.r, safe.w + 2*player.r, safe.h + 2*player.r, player.x, player.y) then
        return
      end
    end
    self.timeout = self.timeout - dt
    if self.timeout <= 0 then
      local Map = map.model
      clean()
      startGame(Map)
    end
  end
  instance.model = Map
  return instance
end